// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUISegmentLayout;
import org.apache.myfaces.tobago.layout.SegmentMeasureList;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a layout using a 12 columns grid.
  Find more information on how the grid works in the Twitter Bootstrap documentation.

  If no attribute is defined, extraSmall="12seg" will be used as default.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.SegmentLayoutTagDeclaration}.
 */
@Generated("component.stg")
public class UISegmentLayout
    extends AbstractUISegmentLayout implements ClientBehaviorHolder {

  public static final String COMPONENT_TYPE = Tags.segmentLayout.componentType();

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.SegmentLayout";


  enum PropertyKeys {
    extraSmall,
    small,
    marginExtraSmall,
    markup,
    large,
    extraLarge,
    marginExtraLarge,
    marginSmall,
    marginMedium,
    customClass,
    medium,
    marginLarge,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  The space-separated definition of the columns for extra small devices.
   Possible values are: segment values between 1 and 12, 'auto' and '*'.
   Example: '1seg 5seg * auto'

  */
  public org.apache.myfaces.tobago.layout.SegmentMeasureList getExtraSmall() {
    return (org.apache.myfaces.tobago.layout.SegmentMeasureList) getStateHelper().eval(PropertyKeys.extraSmall);
  }

  public void setExtraSmall(org.apache.myfaces.tobago.layout.SegmentMeasureList extraSmall) {
    getStateHelper().put(PropertyKeys.extraSmall, extraSmall);
  }

  /**
  The space-separated definition of the columns for small devices.
   Possible values are: segment values between 1 and 12, 'auto' and '*'.
   Example: '1seg 5seg * auto'

  */
  public org.apache.myfaces.tobago.layout.SegmentMeasureList getSmall() {
    return (org.apache.myfaces.tobago.layout.SegmentMeasureList) getStateHelper().eval(PropertyKeys.small);
  }

  public void setSmall(org.apache.myfaces.tobago.layout.SegmentMeasureList small) {
    getStateHelper().put(PropertyKeys.small, small);
  }

  /**
  The space-separated definition of the column margins for extra small devices.
   Allowed values are: none, left, right, both
   Example: 'left none both'

  */
  public java.lang.String getMarginExtraSmall() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.marginExtraSmall);
  }

  public void setMarginExtraSmall(java.lang.String marginExtraSmall) {
    getStateHelper().put(PropertyKeys.marginExtraSmall, marginExtraSmall);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  The space-separated definition of the columns for large devices.
   Possible values are: segment values between 1 and 12, 'auto' and '*'.
   Example: '1seg 5seg * auto'

  */
  public org.apache.myfaces.tobago.layout.SegmentMeasureList getLarge() {
    return (org.apache.myfaces.tobago.layout.SegmentMeasureList) getStateHelper().eval(PropertyKeys.large);
  }

  public void setLarge(org.apache.myfaces.tobago.layout.SegmentMeasureList large) {
    getStateHelper().put(PropertyKeys.large, large);
  }

  /**
  The space-separated definition of the columns for extra large devices.
   Possible values are: segment values between 1 and 12, 'auto' and '*'.
   Example: '1seg 5seg * auto'

  */
  public org.apache.myfaces.tobago.layout.SegmentMeasureList getExtraLarge() {
    return (org.apache.myfaces.tobago.layout.SegmentMeasureList) getStateHelper().eval(PropertyKeys.extraLarge);
  }

  public void setExtraLarge(org.apache.myfaces.tobago.layout.SegmentMeasureList extraLarge) {
    getStateHelper().put(PropertyKeys.extraLarge, extraLarge);
  }

  /**
  The space-separated definition of the column margins for extra large devices.
   Allowed values are: none, left, right, both
   Example: 'left none both'

  */
  public java.lang.String getMarginExtraLarge() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.marginExtraLarge);
  }

  public void setMarginExtraLarge(java.lang.String marginExtraLarge) {
    getStateHelper().put(PropertyKeys.marginExtraLarge, marginExtraLarge);
  }

  /**
  The space-separated definition of the column margins for small devices.
   Allowed values are: none, left, right, both
   Example: 'left none both'

  */
  public java.lang.String getMarginSmall() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.marginSmall);
  }

  public void setMarginSmall(java.lang.String marginSmall) {
    getStateHelper().put(PropertyKeys.marginSmall, marginSmall);
  }

  /**
  The space-separated definition of the column margins for medium devices.
   Allowed values are: none, left, right, both
   Example: 'left none both'

  */
  public java.lang.String getMarginMedium() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.marginMedium);
  }

  public void setMarginMedium(java.lang.String marginMedium) {
    getStateHelper().put(PropertyKeys.marginMedium, marginMedium);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  The space-separated definition of the columns for medium devices.
   Possible values are: segment values between 1 and 12, 'auto' and '*'.
   Example: '1seg 5seg * auto'

  */
  public org.apache.myfaces.tobago.layout.SegmentMeasureList getMedium() {
    return (org.apache.myfaces.tobago.layout.SegmentMeasureList) getStateHelper().eval(PropertyKeys.medium);
  }

  public void setMedium(org.apache.myfaces.tobago.layout.SegmentMeasureList medium) {
    getStateHelper().put(PropertyKeys.medium, medium);
  }

  /**
  The space-separated definition of the column margins for large devices.
   Allowed values are: none, left, right, both
   Example: 'left none both'

  */
  public java.lang.String getMarginLarge() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.marginLarge);
  }

  public void setMarginLarge(java.lang.String marginLarge) {
    getStateHelper().put(PropertyKeys.marginLarge, marginLarge);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}